/* example 4 for exhaustive verification with SPIN */
/* coorectness of Dekker's algorithm for mutual exclusion */

#define true	1
#define false	0
#define Aturn	false
#define Bturn	true

bool x, y, t;

bool a_critical = 0;
bool b_critical = 0;

proctype A() {
	do
	:: 1 ->
		x = true;
		t = Bturn;
		(y == false || t == Aturn);

		/* begin critical section */
		a_critical = 1;
		assert(!b_critical);
		a_critical = 0;
		/* end critical section */

		x = false
	od
}

proctype B() {
	do
	:: 1 ->	
		y = true;
		t = Aturn;
		(x == false || t == Bturn);

		/* begin critical section */
		b_critical = 1;
		assert(!a_critical);
		b_critical = 0;
		/* end critical section */

		y = false /* ; assert(!a_critical) */ 
	od
}

init { run A(); run B() }

